# Record Class StConfiguration

java.lang.Object
java.lang.Record
com.io7m.stonesignal.server.StConfiguration

public record StConfiguration(StConfiguration.Database database, Optional<StConfiguration.OpenTelemetry> openTelemetry, StConfiguration.DeviceAPI deviceAPI, StConfiguration.AdminAPI adminAPI, StConfiguration.DataAPI dataAPI) extends Record
The server configuration.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final record`
  `StConfiguration.AdminAPI`
  `static final record`
  `StConfiguration.DataAPI`
  `static final record`
  `StConfiguration.Database`
  `static enum`
  `StConfiguration.DatabaseKind`
  `static final record`
  `StConfiguration.DeviceAPI`
  `static final record`
  `StConfiguration.OpenTelemetry`
  `static final record`
  `StConfiguration.TLS`
  `static final record`
  `StConfiguration.TLSStore`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `StConfiguration(StConfiguration.Database database, Optional<StConfiguration.OpenTelemetry> openTelemetry, StConfiguration.DeviceAPI deviceAPI, StConfiguration.AdminAPI adminAPI, StConfiguration.DataAPI dataAPI)`
  Creates an instance of a `StConfiguration` record class.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `StConfiguration.AdminAPI`
  `adminAPI()`
  Returns the value of the `adminAPI` record component.
  `StConfiguration.DataAPI`
  `dataAPI()`
  Returns the value of the `dataAPI` record component.
  `StConfiguration.Database`
  `database()`
  Returns the value of the `database` record component.
  `StConfiguration.DeviceAPI`
  `deviceAPI()`
  Returns the value of the `deviceAPI` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `Optional<StConfiguration.OpenTelemetry>`
  `openTelemetry()`
  Returns the value of the `openTelemetry` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### StConfiguration

    public StConfiguration(@JsonPropertyDescription("The database configuration.") StConfiguration.Database database, @JsonPropertyDescription("The OpenTelemetry configuration.") Optional<StConfiguration.OpenTelemetry> openTelemetry, @JsonPropertyDescription("The device API configuration.") StConfiguration.DeviceAPI deviceAPI, @JsonPropertyDescription("The admin API configuration.") StConfiguration.AdminAPI adminAPI, @JsonPropertyDescription("The data API configuration.") StConfiguration.DataAPI dataAPI)
    Creates an instance of a `StConfiguration` record class.
    Parameters:
      `database` - the value for the `database` record component
      `openTelemetry` - the value for the `openTelemetry` record component
      `deviceAPI` - the value for the `deviceAPI` record component
      `adminAPI` - the value for the `adminAPI` record component
      `dataAPI` - the value for the `dataAPI` record component

- ## Method Details

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### database

    @JsonPropertyDescription("The database configuration.") public StConfiguration.Database database()
    Returns the value of the `database` record component.
    Returns:
      the value of the `database` record component

  - ### openTelemetry

    @JsonPropertyDescription("The OpenTelemetry configuration.") public Optional<StConfiguration.OpenTelemetry> openTelemetry()
    Returns the value of the `openTelemetry` record component.
    Returns:
      the value of the `openTelemetry` record component

  - ### deviceAPI

    @JsonPropertyDescription("The device API configuration.") public StConfiguration.DeviceAPI deviceAPI()
    Returns the value of the `deviceAPI` record component.
    Returns:
      the value of the `deviceAPI` record component

  - ### adminAPI

    @JsonPropertyDescription("The admin API configuration.") public StConfiguration.AdminAPI adminAPI()
    Returns the value of the `adminAPI` record component.
    Returns:
      the value of the `adminAPI` record component

  - ### dataAPI

    @JsonPropertyDescription("The data API configuration.") public StConfiguration.DataAPI dataAPI()
    Returns the value of the `dataAPI` record component.
    Returns:
      the value of the `dataAPI` record component